#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;

int n;
int a[maxn];

int sz[maxn];
int cnt[maxn];

vector<int> divisors[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        ++sz[a[i]];
    }

    int maxElement = *max_element(a + 1, a + n + 1);
    long long ans = 0;

    for (int i = 1; i <= maxElement; ++i)
    {
        for (int j = i; j <= maxElement; j += i)
        {
            divisors[j].push_back(i);
        }
    }

    for (int i = 1; i <= n; ++i)
    {
        int sum = 0;

        for (auto d : divisors[a[i]])
        {
            sum += sz[d];
        }

        if (sum != n - i + 1)
        {
            cout << -1 << endl;
            return 0;
        }

        int j = i;

        while (j + 1 <= n && a[j + 1] == a[i])
        {
            ++j;
        }

        if (j == n)
        {
            break;
        }

        for (int k = i; k <= j; ++k)
        {
            ans += (n - k);
        }

        i = j;

        --sz[a[i]];
    }

    cout << ans << endl;

    return 0;
}
