#include <bits/stdc++.h>

using namespace std;

const int maxn = 70;

int n, m;

int a[maxn][maxn];

struct Output
{
    int node;
    int lc;
    int rc;
    char sign;

    Output()
    {

    }

    Output(int _node, int _lc, int _rc, char _sign)
    {
        node = _node;
        lc = _lc;
        rc = _rc;
        sign = _sign;
    }
};

vector<Output> v;

int findNumber(int x, int y)
{
    return (x - 1) * m + y;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    a[1][1] = 1;

    int curr = n * m + 1;

    for (int i = 2; i <= m; ++i)
    {
        a[1][i] = curr;
        v.push_back(Output(curr, findNumber(1, i), a[1][i - 1], '+'));
        ++curr;
    }

    for (int i = 2; i <= n; ++i)
    {
        a[i][1] = curr;
        v.push_back(Output(curr, findNumber(i, 1), a[i - 1][1], '+'));
        ++curr;
    }

    for (int i = 2; i <= n; ++i)
    {
        for (int j = 2; j <= m; ++j)
        {
            int buff = curr;
            ++curr;
            v.push_back(Output(buff, a[i][j - 1], a[i - 1][j - 1], '-'));
            a[i][j] = curr;
            ++curr;
            v.push_back(Output(a[i][j], a[i - 1][j], buff, '+'));
        }
    }

    cout << curr - 1 << endl;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= m; ++j)
        {
            cout << a[i][j] << " ";
        }

        cout << endl;
    }

    for (auto [node, lc, rc, sign] : v)
    {
        cout << node << " = " << lc << " " << sign << " " << rc << endl;
    }

    return 0;
}
