#include <bits/stdc++.h>
using namespace std;

const int MAXN = 200007;

int n, m;
vector<pair<int, int>> G[MAXN];
bool vis[MAXN];

int calc(int x, int k){
    for(int i = 1; i <= n; i++){ vis[i] = false; }
    vis[x] = true;
    priority_queue<pair<int, int>> pq;
    for(int i = 0; i < G[x].size(); i++){
        pq.push({-G[x][i].second, G[x][i].first});
    }
    int maxCost = 0;
    int visCnt = 0;
    while(visCnt < k){
        while(vis[pq.top().second]){ pq.pop(); }
        int node, cost;
        tie(cost, node) = pq.top();
        cost = -cost;
        vis[node] = true;
//        cout << "visit " << node << " (cost " << cost << ")\n";
        visCnt++;
        maxCost = max(maxCost, cost);

        for(int i = 0; i < G[node].size(); i++){
            if(!vis[G[node][i].first]){
                pq.push({-G[node][i].second, G[node][i].first});
            }
        }
    }
    return maxCost;
}


int main(){
    int Q;
    cin >> n >> m >> Q;
    for(int i = 0; i < m; i++){
        int u, v, d;
        cin >> u >> v >> d;
        G[u].push_back({v, d});
        G[v].push_back({u, d});
    }
    vector<pair<int, int>> q;
    for(int i = 0; i < Q; i++){
        int x, k;
        cin >> x >> k;
        q.push_back({x, k});
    }

    for(int i = 0; i < Q; i++){
        cout << calc(q[i].first, q[i].second) << '\n';
    }
//    int calcRes = calc(q[6].first, q[6].second);
//    cout << "RESULT: " << calcRes << '\n';


    return 0;
}
