#include <bits/stdc++.h>
using namespace std;

const int MAXN = 200007;
const int MAXQ = 200007;

int n, m;
vector<pair<int, int>> G[MAXN];
bool vis[MAXN];
int ans[MAXQ];
vector<pair<int, int>> citiesWanted[MAXN]; /// {city count, query idx}

void calc(int x){
    for(int i = 1; i <= n; i++){ vis[i] = false; }
    vis[x] = true;
    priority_queue<pair<int, int>> pq;
    for(int i = 0; i < G[x].size(); i++){
        pq.push({-G[x][i].second, G[x][i].first});
    }
    int maxCost = 0;
    int visCnt = 0;
    int cityCountIdx = 0;
    int k, queryNo;
    tie(k, queryNo) = citiesWanted[x][0];
    while(true){
        while(vis[pq.top().second]){ pq.pop(); }
        int node, cost;
        tie(cost, node) = pq.top();
        cost = -cost;
        vis[node] = true;
//        cout << "visit " << node << " (cost " << cost << ")\n";
        visCnt++;
        maxCost = max(maxCost, cost);

        for(int i = 0; i < G[node].size(); i++){
            if(!vis[G[node][i].first]){
                pq.push({-G[node][i].second, G[node][i].first});
            }
        }
        if(visCnt == k){
            ans[queryNo] = maxCost;
            cityCountIdx++;
            if(citiesWanted[x].size() == cityCountIdx){ break; }
            tie(k, queryNo) = citiesWanted[x][cityCountIdx];
        }
    }
}


int main(){
    int Q;
    cin >> n >> m >> Q;
    for(int i = 0; i < m; i++){
        int u, v, d;
        cin >> u >> v >> d;
        G[u].push_back({v, d});
        G[v].push_back({u, d});
    }
    vector<pair<pair<int, int>, int>> q;
    for(int i = 0; i < Q; i++){
        int x, k;
        cin >> x >> k;
        q.push_back({{x, k}, i});
    }

//    sort(q.begin(), q.end());
    for(int i = 0; i < Q; i++){
        citiesWanted[q[i].first.first].push_back({q[i].first.second, q[i].second});
    }

    for(int i = 0; i < Q; i++){
        calc(q[i].first.first);
    }
    for(int i = 0; i < Q; i++){
        cout << ans[i] << '\n';
    }

    return 0;
}
