#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int ver;
    int d;
    bool operator <(const edge& e)const
    {
        return d>e.d;
    }
};
const int maxn = 4001;
int n, m, q;
vector<edge>v[maxn];

void read()
{
    cin>>n>>m>>q;
    int x, y;int _d;
    for(int i=0;i<m;i++)
    {
        cin>>x>>y>>_d;
        v[x].push_back({y, _d});
        v[y].push_back({x, _d});
    }
}

int r[maxn];
bool used[maxn];

void init(int s)
{
    for(int i=1;i<=n;i++)
    {
        r[i]=INT_MAX;
    }
    r[s]=0;
    memset(used, 0, sizeof(used));
}

void Dijkstra(int s)
{
    init(s);
    priority_queue<edge>q;
    q.push({s, 0});
    while(!q.empty())
    {
        edge e = q.top();
        q.pop();
        if(!used[e.ver])
        {
            used[e.ver] = 1;
            if(e.d<=r[e.ver])
            {
                int sz = v[e.ver].size();
                for(int i=0;i<sz;i++)
                {
                    edge nb = v[e.ver][i];
                    if(r[nb.ver]>=max(r[e.ver],nb.d))
                    {
                        r[nb.ver] = max(r[e.ver] , nb.d);
                        nb.d = r[nb.ver];
                        q.push(nb);
                    }
                }
            }
        }
    }
    /**
    for(int i=1;i<=n;i++)
    {
        cout<<i<<" : "<<r[i]<<" ";
    }
    cout<<endl;
    **/
}

void solve_query(int x, int k)
{
    Dijkstra(x);
    sort(r+1, r+n+1);
    long long maxd = 0;
    for(int i=2;i<=k+1;i++)
    {
        if(maxd<r[i])maxd = r[i];
    }
    //cout<<"ANS: ";
    cout<<maxd<<'\n';
}


void read_query()
{
    int x, k;
    while(q--)
    {
        cin>>x>>k;
        solve_query(x, k);
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    read();
    read_query();
	return 0;
}
