#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int ver;
    int d;
    bool operator <(const edge& e)const
    {
        return d>e.d;
    }
};
const int maxn = 4001;
int n, m, q;
vector<edge>v[maxn];

bool cmp(edge e1, edge e2);

void read()
{
    cin>>n>>m>>q;
    int x, y;int _d;
    for(int i=0;i<m;i++)
    {
        cin>>x>>y>>_d;
        v[x].push_back({y, _d});
        v[y].push_back({x, _d});
    }
    for(int i=1;i<=n;i++)
    {
        sort(v[i].begin(), v[i].end(), cmp);
    }
}

int r[maxn][maxn];
bool used[maxn];
bool cmp(edge e1, edge e2)
{
    return e1.d<e2.d;
}

void init(int s)
{
    for(int i=1;i<=n;i++)
    {
        r[s][i]=INT_MAX;
    }
    r[s][s]=0;
    memset(used, 0, sizeof(used));
}

void Dijkstra(int s, int k)
{
    init(s);
    priority_queue<edge>q;
    q.push({s, 0});
    int br=-1;
    while(!q.empty())
    {
        edge e = q.top();
        q.pop();
        if(br>=k)return;
        if(!used[e.ver])
        {
            //cout<<e.ver<<endl;
            used[e.ver] = 1;
            br++;
            if(e.d<=r[s][e.ver])
            {
                int sz = v[e.ver].size();
                for(int i=0;i<sz;i++)
                {
                    edge nb = v[e.ver][i];
                    if(r[s][nb.ver]>max(r[s][e.ver],nb.d))
                    {
                        r[s][nb.ver] = max(r[s][e.ver] , nb.d);
                        nb.d = r[s][nb.ver];
                        q.push(nb);
                    }
                }
            }
        }
    }
    /**
    for(int i=1;i<=n;i++)
    {
        cout<<i<<" : "<<r[i]<<" ";
    }
    cout<<endl;
    **/
}

void solve_query(int x, int k)
{
    //if(r[x][x]==0)
        Dijkstra(x, k);
    //if(r[x][x]==0)
    //{
        //r[x][x]=1;
        sort(r[x]+1, r[x]+n+1);
    //}
    int maxd = 0;
    for(int i=2;i<=k+1;i++)
    {
        if(maxd<r[x][i])maxd = r[x][i];
    }
    //cout<<"ANS: ";
    cout<<maxd<<'\n';
}


void read_query()
{
    int x, k;
    while(q--)
    {
        cin>>x>>k;
        solve_query(x, k);
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    read();
    read_query();
	return 0;
}
