#include<bits/stdc++.h>
#define MxN 4096
using namespace std;
int table[65][65];
int ftable[65][65][65][65];
int n,m;
vector<tuple<int,int,bool>> nodes;



int lowPow2(int k){
    int res=1;
    while(res<k)res*=2;
    return res/2;
}

int buildTree(int fr,int fc,int r,int c){
    if(ftable[fr][fc][r][c]!=0) return ftable[fr][fc][r][c]; // already exists
    if(fr==r&&fc==c){ // single cell
        ftable[fr][fc][r][c]=(r-1)*m+c;
        return (r-1)*m+c;
    }
    if(fr==r){ // single row
        int lpowC=lowPow2(c);
        nodes.push_back({buildTree(fr,fc,r,lpowC),buildTree(fr,lpowC+1,r,c),1});
        ftable[fr][fc][r][c]=nodes.size()+m*n;
        return ftable[fr][fc][r][c];
    }
    int lpowR=lowPow2(r);
    nodes.push_back({buildTree(fr,fc,lpowR,c),buildTree(lpowR+1,fc,r,c),1});
    ftable[fr][fc][r][c]=nodes.size()+m*n;
    return ftable[fr][fc][r][c];
}
int main(){

    cin>>n>>m;
    // build base tree
    buildTree(1,1,n,m);
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            buildTree(1,1,i,j);
        }
    }
    // Output
    cout<<nodes.size()+m*n<<endl;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            cout<<ftable[1][1][i][j]<<" ";
        }
        cout<<endl;
    }
    for(int i=0;i<nodes.size();i++){
        printf("%d = %d %c %d\n",m*n+i+1,get<0>(nodes[i]),(get<2>(nodes[i])?'+':'-'),get<1>(nodes[i]));
    }
    return 0;
}
