#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 2e5+50;
int64_t n;
bool used[MAXN];
int64_t a[MAXN], first[MAXN], last[MAXN];
set <int64_t> values;
int64_t upToCount[25];
bool check()
{
    stack <int64_t> temp;
    vector <int64_t> reversed;

    for (int64_t val:values)
        temp.push(val);

    while (!temp.empty())
    {
        reversed.push_back(temp.top());
        temp.pop();
    }

    for (int i = 0; i < reversed.size(); i++)
    {
        for (int j = i+1; j < reversed.size(); j++)
        {
            if (reversed[i]%reversed[j] == 0)
                continue;

            if (first[reversed[i]] > last[reversed[j]])
                continue;

            return false;
        }
    }

    return true;
}

void solveSubtask2()
{
    int ans = 0;
    for (int i = 1; i < n; i++)
    {
        for (int j = i; j > 0; j--)
        {
            if (a[j] >= a[j-1])
                break;

            if (a[j-1]%a[j] != 0)
            {
                cout << -1 << endl;
                return;
            }
            ans++;
            swap(a[j], a[j-1]);
        }
    }

    cout << ans << endl;
}

void solveSubtask3()
{
    bool isIncreasing = true;
    int possition1 = 0;

    for (int i = 1; i < n; i++)
    {
        if (a[i] == 1)
        {
            possition1 = i;
            continue;
        }

        if (a[i] < a[i-1])
            isIncreasing = false;
    }

    if (isIncreasing == true)
        cout << possition1 << endl;

    else
        cout << -1 << endl;
}

void solveSubtask4()
{
    bool res = check();
    if (res == false)
    {
        cout << -1 << endl;
        return;
    }

    int64_t ans = 0;
    for (int i = n-1; i >= 0; i--)
    {
        for (int j = a[i]; j <= 22; j++)
            upToCount[j]++;

        ans += upToCount[a[i]-1];
    }

    cout << ans << endl;
}

void solveSubtask5()
{
    bool flag = true;
    for (int i = 1; i < n; i++)
    {
        flag = flag&(a[i-1]%a[i]==0);
    }

    if (flag == false)
    {
        cout << -1 << endl;
    }
    else
    {
        int64_t ans = n*(n-1)/2;
        int64_t br = 1, prev = a[0];
        for (int i = 1; i < n; i++)
        {
            if (a[i] != prev)
            {
                ans -= (br)*(br-1)/2;
                br = 0;
            }

            br++;
            prev = a[i];
        }

        ans -= (br)*(br-1)/2;

        cout << ans << endl;
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    for (int i = 0; i < MAXN; i++)
    {
        first[i] = INT_MAX;
        last[i] = INT_MIN;
    }

    cin >> n;

    for (int64_t i = 0; i < n; i++)
    {
        cin >> a[i];

        values.insert(a[i]);
        first[a[i]] = min(first[a[i]], i);
        last[a[i]] = max(last[a[i]], i);
    }

    int numberOfSubtask = 0;



    bool isPermutation = true, isUpToTwenty = true;
    for (int i = 0; i < n; i++)
    {
        isUpToTwenty = isUpToTwenty&(a[i]<=20);
        if (used[a[i]] == true || a[i] > n)
            isPermutation = false;

        used[a[i]] = true;
    }
    if (n <= 1000)
        numberOfSubtask = 2;

    if (isPermutation == true)
        numberOfSubtask = 3;

    if (isUpToTwenty == true)
        numberOfSubtask = 4;

    if (numberOfSubtask == 0)
        numberOfSubtask = 5;

    if (numberOfSubtask == 2)
    {
        solveSubtask2();
    }

    else if (numberOfSubtask == 3)
    {
        solveSubtask3();
    }

    else if (numberOfSubtask == 4)
    {
        solveSubtask4();
    }
    else if (numberOfSubtask == 5)
    {
        solveSubtask5();
    }

    return 0;
}
