#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 4005, MAXM = 4e5 + 10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m, q;

struct edge
{
    int from, to, val;
    int id;
    edge(){};
    edge(int _from, int _to, int _val, int _id)
    {
        from = _from;
        to = _to;
        id = _id;
        val = _val;
    }
};
bool cmp(edge e1, edge e2)
{
    if(e1.val != e2.val)return (e1.val < e2.val);
    return (e1.id < e2.id);
}
vector < edge > g;
void read()
{
    cin >> n >> m >> q;

    int ff, tt, vv;
    for (int i = 1; i <= m; ++ i)
    {
        cin >> ff >> tt >> vv;
       g.push_back(edge(ff, tt, vv, i));
    }
  //  cout << "sorted ok" << endl;
   sort(g.begin(), g.end(), cmp);
  // cout << "sorted ok" << endl;
}
int p[MAXN], sz[MAXN];

void init()
{
    for (int i = 1; i <= n; ++ i)
    {
        p[i] = i;
        sz[i] = 1;
    }
}
int ver, need;


int ans, res[MAXN][MAXN];
pair <int, int> find_parent(int i)
{
    if(i == p[i])return make_pair(i, sz[i]);
    pair < int, int > fromup = find_parent(p[i]);
    p[i] = fromup.first;
    sz[i] = fromup.second;
    //if(!res[i][sz[i]])res[i][sz[i]] = ans;
    return fromup;
}

void connect(int x, int y)
{
    x = find_parent(x).first;
    y = find_parent(y).first;

    if(x == y)return;
    if(ver == y)swap(x, y);
    sz[x] += sz[y];
    if(!res[y][sz[x]])res[y][sz[x]] = ans;
    p[y] = x;
}
void solve()
{
    if(res[ver][need+1])
    {
        cout << res[ver][need+1] << endl;
        return;
    }
    init();
   // cout << "here" << endl;
    int i = -1;
    ans = 0;
    while(sz[ver] <= need)
    {
        i ++;

        int fromm = g[i].from;
        int too = g[i].to;
        connect(fromm, too);
        ans = g[i].val;
    }
    cout << ans << endl;
}
void queries()
{
    while(q --)
    {
        cin >> ver >> need;
        solve();
    }
}
int main()
{
   speed();
   read();
   queries();
    return 0;
}
/***
13 18 1
1 2 4
1 3 1
2 4 6
2 5 4
2 6 2
3 6 3
3 10 4
4 7 6
5 8 5
6 8 2
10 11 6
7 8 5
11 12 7
12 8 6
7 9 5
9 13 6
13 8 1
5 6 3
13 6

*/
