#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 4005, MAXM = 4e5 + 10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m, q;

struct edge
{
    int from, to, val;
    int id;
    edge(){};
    edge(int _from, int _to, int _val, int _id)
    {
        from = _from;
        to = _to;
        id = _id;
        val = _val;
    }
};
bool cmp(edge e1, edge e2)
{
    if(e1.val != e2.val)return (e1.val < e2.val);
    return (e1.id < e2.id);
}
vector < edge > g;
void read()
{
    cin >> n >> m >> q;

    int ff, tt, vv;
    for (int i = 1; i <= m; ++ i)
    {
        cin >> ff >> tt >> vv;
       g.push_back(edge(ff, tt, vv, i));
    }
  //  cout << "sorted ok" << endl;
   sort(g.begin(), g.end(), cmp);
  // cout << "sorted ok" << endl;
}
int p[MAXN], sz[MAXN];

void init()
{
    for (int i = 1; i <= n; ++ i)
    {
        p[i] = i;
        sz[i] = 1;
    }
}


int ans, res[MAXN][MAXN];
pair <int, int> find_parent(int i)
{
    if(i == p[i])return make_pair(i, sz[i]);
    pair < int, int > fromup = find_parent(p[i]);
    p[i] = fromup.first;
    sz[i] = fromup.second;

    return fromup;
}
int fake = 0;
void connect(int x, int y)
{
    x = find_parent(x).first;
    y = find_parent(y).first;

    if(x == y)
    {
        fake = 1;
        return;
    }
    sz[x] += sz[y];
    p[y] = x;
}
int last[MAXN];
void solve()
{

    init();
    int i = 0;
    ans = 0;
    while(i < g.size())
    {


        int fromm = g[i].from;
        int too = g[i].to;
        fake = 0;
        connect(fromm, too);
        ans = g[i].val;
        if(!fake)
        {
            for (int ver = 1; ver <= n; ++ ver)
        {
            int news = find_parent(ver).second;
           ///cout << ver << "**  " << news << "--> " << ans << endl;
            if(!res[ver][news])
            {
                for (int jj = last[ver]+1; jj <= news; ++ jj)
                    res[ver][jj] = ans;
                last[ver] = news;
            }
        }
        }
        i ++;
    }

}
void queries()
{
    solve();

    while(q --)
    {
        int ver, need;
        cin >> ver >> need;

        cout << res[ver][need+1] << endl;

    }
}
int main()
{
   speed();
   read();
   queries();
    return 0;
}
/***
13 18 1
1 2 4
1 3 1
2 4 6
2 5 4
2 6 2
3 6 3
3 10 4
4 7 6
5 8 5
6 8 2
10 11 6
7 8 5
11 12 7
12 8 6
7 9 5
9 13 6
13 8 1
5 6 3
13 6

*/
