#include<iostream>
using namespace std;

const int N_MAX=64,M_MAX=64,NODES_MAX=300000;

void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
}

struct vryh{
    bool sign; //1='+'   0='-'
    int l,r;
};

vryh vertex[NODES_MAX];
int n,m;

int main(){
fastIO();

    cin>>n>>m;

    int pref[n][m],curr=n*m+1;
    pref[0][0]=1;

    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++){
            if(!i && !j)continue;
            if(!i){
                vertex[curr].l=pref[i][j-1];
                vertex[curr].r=j+1;
                vertex[curr].sign=1;
                pref[i][j]=curr;
                curr++;
                continue;
            }
            if(!j){
                vertex[curr].l=pref[i-1][j];
                vertex[curr].r=i*m+1;
                vertex[curr].sign=1;
                pref[i][j]=curr;
                curr++;
                continue;
            }

            vertex[curr].l=pref[i-1][j];;
            vertex[curr].r=pref[i-1][j-1];
            vertex[curr].sign=0;
            curr++;

            vertex[curr].l=curr-1;
            vertex[curr].r=pref[i][j-1];
            vertex[curr].sign=1;
            curr++;

            vertex[curr].l=curr-1;
            vertex[curr].r=i*m+j+1;
            vertex[curr].sign=1;
            pref[i][j]=curr;
            curr++;
        }

    cout<<curr<<'\n';

    for(int i=0; i<n; i++){
        for(int j=0; j<m; j++)
            cout<<pref[i][j]<<' ';
        cout<<'\n';
    }

    for(int i=n*m+1; i<curr; i++){
        cout<<i<<" = "<<vertex[i].l;
        if(vertex[i].sign)cout<<" + ";
        else cout<<" - ";
        cout<<vertex[i].r<<'\n';
    }
    cout<<curr<<" = "<<curr-1<<" + "<<pref[3][3]<<'\n';
return 0;
}