#include<iostream>
#include<queue>
#include<vector>
#include<cstring>
#define MAXN 200010
#define MAXD 1000000010
using namespace std;
vector<pair<int,int>> edges[MAXN];
bool used[MAXN];
bool check(int lim, int n, int st, int k)
{
    queue<int> q;
    int cntr=0;
    q.push(st);
    memset(used,0,n+1);
    used[st]=1;
    while(!q.empty())
    {
        int curr=q.front();
        q.pop();
        for(int i=0;i<edges[curr].size();i++)
        {
            int now=edges[curr][i].first;
            int cost=edges[curr][i].second;
            if(cost<=lim && !used[now])
            {
                used[now]=1;
                cntr++;
                q.push(now);
            }
        }
        if(cntr>=k)return 1;
    }
    return 0;
}
int main()
{
    int n,m,q;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m>>q;
    for(int i=0;i<m;i++)
    {
        int u,v,x;
        cin>>u>>v>>x;
        edges[u].push_back({v,x});
        edges[v].push_back({u,x});
    }
    for(int t=0;t<q;t++)
    {
        int st,k;
        cin>>st>>k;
        int l=1,r=MAXD;
        while(l!=r)
        {
            int mid=(l+r)>>1;
            if(check(mid,n,st,k))r=mid;
            else l=mid+1;
        }
        cout<<l<<"\n";
    }
}