#include <bits/stdc++.h>
using namespace std;

struct edge
{
    int x,y,z;
    edge(int _x,int _y,int _z)
    {
        x=_x;
        y=_y;
        z=_z;
    }

    bool operator<(const edge&e)const
    {
        return z<e.z;
    }
};
int n,m,q;
vector<edge> e;
vector<pair<int,int> > v[200001];

bool cmp(pair<int,int> p1,pair<int,int> p2)
{
    return p1.first>p2.first;
}

void read()
{
    cin>>n>>m>>q;
    for(int i=1;i<=m;i++)
    {
        int x,y,z;
        cin>>x>>y>>z;
        e.push_back({x,y,z});
    }

    sort(e.begin(),e.end());

    for(int i=1;i<=q;i++)
    {
        int x,z;
        cin>>x>>z;
        v[x].push_back({z,i});
    }

    for(int i=1;i<=n;i++)
        sort(v[i].begin(),v[i].end(),cmp);
}

int l[200001];
int sz[200001];
int ans[200001];

int find_l(int x)
{
    if(x==l[x])return x;
    return l[x]=find_l(l[x]);
}

vector<int> f[200001];
void unite(int x,int y,int val)
{
    x=find_l(x);
    y=find_l(y);
    if(x!=y)
    {
        if(sz[x]>sz[y])swap(x,y);
        l[x]=y;
        sz[y]+=sz[x];

        while(f[x].size())
        {
            f[y].push_back(f[x][f[x].size()-1]);
            f[x].pop_back();
        }

        for(int i=0;i<f[y].size();i--)
        {
            int ver=f[y][i];
            int j=v[ver].size()-1;
            while(j>=0&&v[ver][j].first<=sz[y])
            {
                ans[v[ver][j].second]=val;
                v[ver].pop_back();
                j--;
            }
        }
    }
}

void solve()
{
    for(int i=0;i<m;i++)
    {
        unite(e[i].x,e[i].y,e[i].z);
    }

    for(int i=1;i<=q;i++)
        cout<<ans[i]<<" ";
    cout<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
    return 0;
}
