#include <bits/stdc++.h>
using namespace std;

struct edge
{
    int x,y,z;
    edge(int _x,int _y,int _z)
    {
        x=_x;
        y=_y;
        z=_z;
    }

    bool operator<(const edge&e)const
    {
        return z<e.z;
    }
};
int n,m,q;
int qr=-1;
vector<edge> e;
vector<pair<int,int> > v[400001];

bool cmp(pair<int,int> p1,pair<int,int> p2)
{
    return p1.first>p2.first;
}

int ans[400001];
void read()
{
    cin>>n>>m>>q;
    for(int i=1; i<=m; i++)
    {
        int x,y,z;
        cin>>x>>y>>z;
        e.push_back({x,y,z});
    }

    sort(e.begin(),e.end());

    for(int i=1; i<=q; i++)
    {
        int x,z;
        cin>>x>>z;
        v[x].push_back({z+1,i});
        qr=z;
    }

    for(int i=1; i<=n; i++)
        sort(v[i].begin(),v[i].end(),cmp);
}

int l[200001];
int sz[200001];

int find_l(int x)
{
    if(x==l[x])return x;
    return l[x]=find_l(l[x]);
}

vector<int> f[200001];

void do_(int y,int val)
{
    for(int i=0; i<f[y].size(); i++)
    {
        int ver=f[y][i];
        //cout<<ver<<endl;
        int j=v[ver].size()-1;
        while(j>=0&&v[ver][j].first<=sz[y])
        {
            ans[v[ver][j].second]=val;
            v[ver].pop_back();
            j--;
        }
    }
}

void unite(int x,int y,int val)
{
    x=find_l(x);
    y=find_l(y);
    if(x!=y)
    {
        //cout<<x<<" * "<<y<<" "<<val<<endl;
        if(sz[x]>sz[y])swap(x,y);

        l[x]=y;
        sz[y]+=sz[x];
        /*for(int i=0;i<f[x].size();i++)
            cout<<f[x][i]<<" ";
        cout<<endl;

        for(int i=0;i<f[y].size();i++)
            cout<<f[y][i]<<" ";
        cout<<endl;*/

        if(sz[y]>=qr)
        {
            do_(y,val);
            do_(x,val);

            f[x].clear();
            f[y].clear();
        }
        else
        {
            while(f[x].size())
            {
                //cout<<"in"<<endl;
                f[y].push_back(f[x][f[x].size()-1]);
                f[x].pop_back();
            }
            f[x].clear();
        }
    }
}

void solve()
{
    for(int i=1; i<=n; i++)
    {
        sz[i]=1;
        f[i].push_back(i);
        l[i]=i;
    }
    for(int i=0; i<m; i++)
    {
        unite(e[i].x,e[i].y,e[i].z);
    }

    for(int i=1; i<=q; i++)
        cout<<ans[i]<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
    return 0;
}
