#include<bits/stdc++.h>
using namespace std;
const int MAXN = 200007;
long long INF = 10000000007;
int m,n,q;
vector<pair<int,long long>> g[MAXN];
long long dist[MAXN];
long long ans[MAXN];
long long Dijkstra(int x, int k){
    for(int i = 1 ; i <= n ; i++) dist[i] = INF;
    priority_queue<pair<int,int>> pq;
    pq.push({0,x});
    int u, v;
    long long d;
    int br = 0;
    while(!pq.empty()){
        d = - pq.top().first;
        u = pq.top().second;
        pq.pop();
        if(d >= dist[u]) continue;
        dist[u] = d;
        if(br == k) return d;
        br++;
        for(int i = 0 ; i < g[u].size() ; i++){
            v = g[u][i].first;
            if(dist[v] > max(d,g[u][i].second)){
                pq.push({-max(d,g[u][i].second), v});
            }
        }
    }
    return -1;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m>>q;
    int u, v;
    long long d;
    for(int i = 0 ; i < m ; i++){
        cin>>u>>v>>d;
        g[u].push_back({v,d});
        g[v].push_back({u,d});
        ans[u] = min(ans[u],d);
        ans[v] = min(ans[v],d);
    }
    int x,k;
    if(k == 1){
        for(int i = 0 ; i < q ; i++){
        cin>>x>>k;
        cout<<ans[x]<<"\n";
        }
        return 0;
    }
    for(int i = 0 ; i < q ; i++){
        cin>>x>>k;
        cout<<Dijkstra(x,k)<<"\n";
    }
    return 0;
}
