#include<bits/stdc++.h>
using namespace std;
const int MAXN = 200007;
long long MAXD = 0;
int m,n,q;
vector<pair<int,long long>> g[MAXN];
bitset<MAXN> vis;
int br;
vector<long long> costs;
void DFS(int u, int mx, int k){
    if(br >= k) return;
    br++;
    vis[u] = true;
    int v;
    for(int i = 0; i < g[u].size() ; i++){
        v = g[u][i].first;
        if(g[u][i].second > mx) continue;
        if(!vis[v]) DFS(v,mx,k);
    }
}
bool check(long long ans,int x,int k){
    br = -1;
    vis.reset();
    DFS(x,ans,k);
    return (br >= k);
}
int BS(int x,int k){
    long long l = 0;
    long long r = n;
    long long mid;
    while(r-l > 1){
        mid = (l+r)/2;
        if(check(costs[mid],x,k)){
            r = mid;
        }else{
            l = mid+1;
        }
    }
    if(check(costs[l],x,k)) return costs[l];
    return r;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m>>q;
    int u, v;
    long long d;
    //for(int i = 1 ; i <= n ; i++) ans[i] = INF;
    for(int i = 0 ; i < m ; i++){
        cin>>u>>v>>d;
        g[u].push_back({v,d});
        g[v].push_back({u,d});
        MAXD = max(MAXD, d);
        costs.push_back(d);
    }
    sort(costs.begin(), costs.end());
    int x,k;
    for(int i = 0 ; i < q ; i++){
        cin>>x>>k;
        cout<<BS(x,k)<<"\n";
    }
}
