#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

#define pb(x) push_back(x)
#define INF 1000000005
#define LINF 1000000000000000005
#define maxn 200005

typedef long long ll;

using namespace std;

int n;
ll a[maxn];

void read()
{
    cin >> n;

    for(int i = 1; i <= n; i++)
        cin >> a[i];
}


void solve()
{
    int ans = 0;
    int br = 0;

    br = 1;
    ll gcd = a[1];
    for(int i = 2; i <= n; i++)
    {
        gcd = __gcd(gcd , a[i]);
        if(a[i] == a[i - 1])
            br++;
        else
            ans += br , br = 0;
    }

    if(gcd == 1)
        cout << -1 << endl;
    else
        cout << ans << endl;

}





int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    read();
    solve();

    return 0;
}
