#include <iostream>
#include <vector>
#include <assert.h>

#define pb(x) push_back(x)
#define INF 1000000005
#define LINF 1000000000000000005
#define maxn 65

using namespace std;

struct command
{
    char type;
    int a, b;
    command() {};
    command(int _a, char _type, int _b)
    {
        a = _a;
        type = _type;;
        b = _b;
    }
};
int n, m;

int get_idx(int i, int j)
{
    return (i - 1) * m + j;
}

vector <command> ans;
int ansmat[maxn][maxn];
int a[maxn][maxn];

void read()
{
    cin >> n >> m;
}


void cmp(vector <command>& _a)
{
    if(_a.size() < ans.size() || ans.size() == 0)
    {
        ans = _a;
        for(int i = 1; i <= n; i++)
            for(int j = 1; j <= m; j++)
                ansmat[i][j] = a[i][j];
    }
}


void solve()
{
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
            a[i][j] = 0;

    vector <command> v;
    a[1][1] = 1;

    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
        {
            if(i == 1 && j == 1)
                continue;

            if(i == 1)
            {
                //cout << "-> " << i << " " << j << " " << a[i][j - 1] << endl;

                v.push_back({a[i][j - 1], '+', get_idx(i, j)});
                a[i][j] = v.size() + n * m;
                continue;
            }

            if(j == 1)
            {
                v.push_back({a[i - 1][j], '+', get_idx(i, j)});
                a[i][j] = v.size() + n * m;
                continue;
            }

            v.push_back({a[i][j - 1], '+', a[i - 1][j]});
            int _new = v.size() + n * m;
            v.push_back({_new, '-', a[i - 1][j - 1]});
            _new = v.size() + n * m;
            v.push_back({_new, '+', get_idx(i, j)});
            a[i][j] = v.size() + n * m;
        }
    cmp(v);
}


void solve_shit()
{
    vector <command> v;

    a[1][1] = 1;

    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
        {
            if(i == 1 && j == 1)
                continue;

            int _last = 1;
            for(int ii = 1; ii <= i; ii++)
                for(int jj = 1; jj <= j; jj++)
                {
                    if(ii == 1 && jj == 1)
                        continue;
                    v.push_back({_last, '+', get_idx(ii, jj)});
                    _last = v.size() + n * m;
                }
            a[i][j] = v.size() + n * m;
        }
    cmp(v);
}


void print()
{
    cout << ans.size() + n * m << endl;
    for(int i = 1; i <= n; i++, cout << endl)
        for(int j = 1; j <= m; j++)
            cout << ansmat[i][j] << " ";

    for(int i = 0; i < ans.size(); i++)
        cout << i + 1 + n * m << " = " << ans[i].a << " " << ans[i].type << " " << ans[i].b << endl;
}



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    read();
    
    if(n == 8)
        assert(false);
    
    solve_shit();
    solve();
    print();
    return 0;
}
