#include<bits/stdc++.h>
using namespace std;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}
struct edge
{
    int v,d;
    edge() {}
    edge(int _v,int _d)
    {
        v=_v;
        d=_d;
    }
    bool operator<(const edge &e)const
    {
        return e.d<d;
    }
};
const int maxn=2*1e5+2;
const int maxm=maxn*2;
int n,m,q;
int x[maxn],k[maxn];
vector<edge>v[maxn];
int used[maxn];
unsigned int d[maxn];
int flag=0;
void read()
{
    cin>>n>>m>>q;
    int a,b,c;
    for(int i=1; i<=m; i++)
    {
        cin>>a>>b>>c;
        edge e(b,c);
        v[a].push_back(e);
        e.v=a;
        v[b].push_back(e);
    }
    for(int i=1; i<=q; i++)
    {
        cin>>x[i]>>k[i];
        if(k[i]!=1)flag=1;
    }
}
void dijkstra(int s)
{
    priority_queue<edge>q;
    edge w(s,0);
    d[s]=0;
    q.push(w);
    edge nb;
    int sz;
    while(!q.empty())
    {
        w=q.top();
        q.pop();
        if(d[w.v]>=w.d)
        {
            if(!used[w.v])
            {
                used[w.v]=1;
                sz=v[w.v].size();
                for(int i=0; i<sz; i++)
                {
                    nb=v[w.v][i];
                    if(d[nb.v]>=max((int)d[w.v],nb.d))
                    {
                        d[nb.v]=max((int)d[w.v],nb.d);
                        nb.d=d[nb.v];
                        q.push(nb);
                    }
                }
            }
        }
    }
}
void solve()
{
    if(flag)
    {
        for(int z=1; z<=q; z++)
        {
            memset(used,0,sizeof(used));
            memset(d,-1,sizeof(d));
            dijkstra(x[z]);
            sort(d+1,d+n+1);
            cout<<d[k[z]+1]<<endl;
        }
    }
    else
    {
        for(int z=1; z<=q; z++)
        {
            int sz=v[x[z]].size();
            int ans=1e9;
            for(int i=1;i<=sz;i++)
            {
                if(v[x[z]][i].d<ans)ans=v[x[z]][i].d;
            }
            cout<<ans<<endl;
        }
    }
}
int main()
{
    speed();
    read();
    solve();

    return 0;
}
