#include <bits/stdc++.h>

using namespace std;

struct edge
{
    int ver;
    int d;
    bool operator <(const edge& e)const
    {
        return d>e.d;
    }
};
const int maxn = 4001;
int n, m, _q;
vector<edge>v[maxn];

bool cmp(edge e1, edge e2);

void read()
{
    cin>>n>>m>>_q;
    int x, y;int _d;
    for(int i=0;i<m;i++)
    {
        cin>>x>>y>>_d;
        v[x].push_back({y, _d});
        v[y].push_back({x, _d});
    }
    for(int i=1;i<=n;i++)
    {
        sort(v[i].begin(), v[i].end(), cmp);
    }
}

int r[maxn][maxn];
int aq[maxn][maxn];
bool used[maxn][maxn];
int kused[maxn], br[maxn];
bool cmp(edge e1, edge e2)
{
    return e1.d<e2.d;
}
priority_queue<edge>q[maxn];
void init()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            r[i][j]=INT_MAX;
        }
        r[i][i]=0;
        q[i].push({i, 0});
    }
}

void Dijkstra(int s, int k)
{
    ///cout<<r[s][s]<<endl;
    while(!q[s].empty())
    {
        if(br[s]>=k)return;
        edge e = q[s].top();
        q[s].pop();
        if(!used[s][e.ver])
        {
            //cout<<e.ver<<endl;
            used[s][e.ver] = 1;
            br[s]++;
            if(e.d<=r[s][e.ver])
            {
                int sz = v[e.ver].size();
                for(int i=0;i<sz;i++)
                {
                    edge nb = v[e.ver][i];
                    if(r[s][nb.ver]>max(r[s][e.ver],nb.d))
                    {
                        r[s][nb.ver] = max(r[s][e.ver] , nb.d);
                        //assert(s!=nb.ver);
                        nb.d = r[s][nb.ver];
                        q[s].push(nb);
                    }
                }
            }
        }
    }
    /**
    cout<<s<<endl;
    for(int i=1;i<=n;i++)
    {
        cout<<i<<" : "<<r[s][i]<<" ";
    }
    cout<<endl;
    cout<<r[s][s]<<endl;
    **/
}

int max1k(int x, int k)
{
    list<int>l;
    for(int i=1;i<=n;i++)
    {
        if(l.size()<=k)
        {
            l.push_back(r[x][i]);
        }
        else
        {
            int maxn = 0;
            list<int>::iterator p;
            for(auto it=l.begin(); it!=l.end();++it)
            {
                int val = *it;
                if(val>maxn)
                {
                    maxn = val;
                    p = it;
                }
            }
            if(r[x][i]<maxn)
            {
                *p = r[x][i];
            }
        }

    }
    int maxn = 0;
    for(auto it=l.begin(); it!=l.end(); ++it)
    {
        int val = *it;
        if(val>maxn)
        {
            maxn = val;

        }
    }
    return maxn;
}

void solve_query(int x, int k)
{
     if(kused[x]<k)
     {
         kused[x]=k;
         Dijkstra(x, k);
         //sort(r[x]+1, r[x]+n+1)
     }
    int maxd = max1k(x, k);
    ///cout<<"ANS: ";
    cout<<maxd<<'\n';
}


void read_query()
{
    int x, k;
    init();
    /**
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cout<<r[i][j]<<" ";
        }
        cout<<endl;
    }
    **/
    while(_q--)
    {
        cin>>x>>k;
        solve_query(x, k);
    }
    /**
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            cout<<r[i][j]<<" ";
        }
        cout<<endl;
    }
    **/
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    read();
    read_query();
	return 0;
}
