#include<iostream>
using namespace std;
struct Node{
    int left;
    int right;
    bool isPlus;
    Node(){
        left = -1;
        right = -1;
        isPlus = false;
    }
    Node(int l, bool p, int r){
        left = l;
        right = r;
        isPlus = p;
    }
    void print(){
        cout<<" = "<<left+1<<(isPlus?" + ":" - ")<<right+1<<"\n";
    }
};
Node nodes[100000];
int n, m;
int br;
int table[64][64];

int indOf(int y, int x){
    return y*m + x;
}
void printAll(){
    cout<<br<<"\n";
    for(int y=0; y<n; y++){
        for(int x=0; x<m; x++){
            cout<<table[y][x]+1<<" ";
        }
        cout<<"\n";
    }
    for(int i=n*m; i<br; i++){
        cout<<i+1;
        nodes[i].print();
    }
}
void setOn(int y, int x){
    nodes[br] = Node(table[y-1][x], true, table[y][x-1]);
    br++;
    nodes[br] = Node(br-1, true, indOf(y, x));
    br++;
    nodes[br] = Node(br-1, false, table[y-1][x-1]);
    table[y][x] = br;
    br++;
}


int main(){
    /// ios_base::sync_with_stdio(false);
    /// cin.tie(nullptr);
    cin>>n>>m;
    br = n*m;

    /// reset table
    for(int y=0; y<n; y++){
        for(int x=0; x<m; x++){
            table[y][x] = -1;
        }
    }
    table[0][0] = 0;

    /// first row
    nodes[br] = Node(indOf(0, 0), true, indOf(0, 1));
    table[0][1] = br;
    br++;

    for(int x=2; x<m; x++){
        nodes[br] = Node(br-1, true, indOf(0, x));
        table[0][x] = br;
        br++;
    }

    /// first colum
    nodes[br] = Node(indOf(0, 0), true, indOf(1, 0));
    table[1][0] = br;
    br++;

    for(int y=2; y<n; y++){
        nodes[br] = Node(br-1, true, indOf(y, 0));
        table[y][0] = br;
        br++;
    }

    /// rest
    for(int y=1; y<n; y++){
        for(int x=1; x<m; x++){
            setOn(y, x);
        }
    }



    printAll();
    return 0;
}
/// 64*64 + 63 + 63 = 4222
/// 4222 + 63*63*3 = 16129
