#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 70;
const int MAXNODES = 3e5+10;
int mapped[MAXN][MAXN], a[MAXN][MAXN];
int currAvailable;

struct Info
{
    int number, child1, child2;
    bool operation;

    Info(){}
    Info(int number, int child1, int child2, bool operation)
        :number(number), child1(child1), child2(child2), operation(operation){}
};

Info nodes[MAXNODES];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int N, M;
    cin >> N >> M;

    currAvailable = N*M + 1;
    mapped[0][0] = 1;

    for (int i = 0; i < N; i++)
    {
        for (int j = 0; j < M; j++)
        {
            a[i][j] = i*M + j+1;
        }
    }
    for (int i = 1; i < N; i++)
    {
        mapped[i][0] = currAvailable;
        nodes[currAvailable] = Info(currAvailable, mapped[i-1][0], a[i][0], true);
        currAvailable++;
    }

    for (int i = 1; i < M; i++)
    {
        mapped[0][i] = currAvailable;
        nodes[currAvailable] = Info(currAvailable, mapped[0][i-1], a[0][i], true);
        currAvailable++;
    }

    for (int i = 1; i < N; i++)
    {
        for (int j = 1; j < M; j++)
        {
            mapped[i][j] = currAvailable+2;
            nodes[currAvailable] = Info(currAvailable, mapped[i-1][j], mapped[i][j-1], true);
            nodes[currAvailable+1] = Info(currAvailable+1, currAvailable, a[i][j], true);
            nodes[currAvailable+2] = Info(currAvailable+2, currAvailable+1, mapped[i-1][j-1], false);
            currAvailable += 3;
        }
    }

    cout << currAvailable-1 << endl;
    for (int i = 0; i < N; i++)
    {
        cout << mapped[i][0];

        for (int j = 1; j < M; j++)
            cout << " " << mapped[i][j];

        cout << endl;
    }

    for (int i = M*N+1; i < currAvailable; i++)
    {
        cout << nodes[i].number << " = " << nodes[i].child1;
        if (nodes[i].operation == true)
            cout << " + ";

        else
            cout << " - ";

        cout << nodes[i].child2 << endl;
    }

    return 0;
}
