#include<iostream>
#include<set>
#include<algorithm>
#include<vector>
using namespace std;
const int MAX_N=2e5+5;
set<pair<int,int>>que[MAX_N];
int parent[MAX_N];
int sz[MAX_N];
int n,q;
int ans[MAX_N];
int curedge;
vector<pair<int,pair<int,int>>>edges;
int m;
int Find(int u)
{
    if(u==parent[u])return u;
    return parent[u]=Find(parent[u]);
}
void Merge(int u,int v)
{
    int urt=Find(u);
    int vrt=Find(v);

    if(urt==vrt)return;

    if(sz[urt]>sz[vrt])swap(urt,vrt);

    int nsz=sz[urt]+sz[vrt]-1;

    while(que[urt].size())
    {
        auto curqueri=(*que[urt].begin());

        int k=curqueri.first,idx=curqueri.second;

        if(k<=nsz)
        {
            que[urt].erase(curqueri);
            ans[idx]=curedge;
        }
        else break;
    }

    while(que[vrt].size())
    {
        auto curqueri=(*que[vrt].begin());

        int k=curqueri.first,idx=curqueri.second;

        if(k<=nsz)
        {
            que[vrt].erase(curqueri);
            ans[idx]=curedge;
        }
        else break;
    }

    parent[urt]=vrt;
    sz[vrt]+=sz[urt];

    for(auto curqueri:que[urt])que[vrt].insert(curqueri);
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>m>>q;

    for(int i=1;i<=m;i++)
    {
        int u,v,d;
        cin>>u>>v>>d;
        edges.push_back({d,{u,v}});
    }
    sort(edges.begin(),edges.end());

    for(int i=1;i<=q;i++)
    {
        int x,k;
        cin>>x>>k;
        que[x].insert({k,i});
    }

    for(int i=1;i<=n;i++){parent[i]=i;sz[i]=1;}

    for(int i=0;i<m;i++)
    {
        int u=edges[i].second.first,v=edges[i].second.second,d=edges[i].first;
        curedge=d;

        Merge(u,v);
    }

    for(int i=1;i<=q;i++)
    {
        cout<<ans[i]<<"\n";
    }

    return 0;
}
