#include<iostream>
#include<map>
#include<tuple>
using namespace std;
const int MAX_N=70;
const int LOG=7;

int n,m;

int cnt;

map<int,pair<int,int>>s;

int spars[2][MAX_N][MAX_N][LOG];
int fen[2][MAX_N][MAX_N];
int high[MAX_N];

void makespars(int row,bool rot)
{
    /*for(int j=1;j<LOG;j++)
    {
        for(int i=(1<<j);i<=(rot==0 ? m : n);i++)
        {
            int left=spars[rot][row][i-(1<<(j-1))][j-1];
            int right=spars[rot][row][i][j-1];
            s[++cnt]={left,right};
            spars[rot][row][i][j]=cnt;
        }
    }*/

    for(int i=3;i<=(rot==0 ? m : n);i++)
    {
        for(int j=1;j<=high[i];j++)
        {
            int left=spars[rot][row][i-(1<<(j-1))][j-1];
            int right=spars[rot][row][i][j-1];
            s[++cnt]={left,right};
            spars[rot][row][i][j]=cnt;
        }
    }
}

void makefen(int row,bool rot)
{
    for(int i=1;i<=(rot==0 ? m : n);i++)
    {
        int left=fen[rot][row][i-(1<<high[i])];
        int right=spars[rot][row][i][high[i]];

        if(left==0)
        {
            fen[rot][row][i]=right;
        }
        else
        {
            s[++cnt]={left,right};
            fen[rot][row][i]=cnt;
        }
    }
}

int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    for(int i=1;i<=64;i++)
    {
        for(int j=LOG-1;j>=0;j--)
        {
            if(((1<<j)&(i))!=0){high[i]=j;break;}
        }
    }

    cin>>n>>m;
    cnt=n*m;

    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            spars[0][i][j][0]=(i-1)*m+j;
        }
        makespars(i,0);
        makefen(i,0);
    }

    for(int i=1;i<=m;i++)
    {
        for(int j=1;j<=n;j++)
        {
            spars[1][i][j][0]=fen[0][j][i];
        }
        makespars(i,1);
        makefen(i,1);
    }

    cout<<cnt<<"\n";return 0;

    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cout<<fen[1][j][i]<<" ";
        }
        cout<<"\n";
    }

    for(int idx=n*m+1;idx<=cnt;idx++)
    {
        cout<<idx<<" = ";

        int left,right;

        tie(left,right)=s[idx];

        cout<<left<<" + ";
        cout<<right<<"\n";
    }



    return 0;
}
