#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 4005;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m, q;

vector < pair < int, int > > g[MAXN];
void read()
{
    cin >> n >> m >> q;
    int from, to, w;
    for (int i = 1; i <= m; ++ i)
    {
        cin >> from >> to >> w;
        g[from].push_back({to, w});
        g[to].push_back({from, w});
    }
}
int ver, need;
int used[MAXN], cnt = 0;
int lv;
void dfs(int beg)
{
    used[beg] = 1;
    if(beg != ver)cnt ++;
    if(cnt == need)return;
    int nb, cost;
    for (int i = 0; i < g[beg].size(); ++ i)
    {
        nb = g[beg][i].first;
        cost = g[beg][i].second;
        if(!used[nb] && cost <= lv)
        {
            dfs(nb);
        }
    }
}
bool check(int x)
{
    memset(used, 0, sizeof(used));
    lv = x;
    cnt = 0;
    dfs(ver);
    return (cnt >= need);
}
void solve()
{

    long long l = 0, r = 1e9, mid, ans = 1e9 + 10;
    while(l <= r)
    {
        mid = 1LL * ((l + r)/2);
        if(check(mid))
        {
            r = mid - 1;
            ans = mid;
        }
        else l = mid + 1;
    }
    cout << ans << endl;
}
void queries()
{
    while(q --)
    {
        cin >> ver >> need;
        solve();
    }
}
int main()
{
    speed();
   read();
   queries();
    return 0;
}
