#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 4005, MAXM = 4e5 + 10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n, m, q;

struct edge
{
    int from, to, val;
    int id;
    edge(){};
    edge(int _from, int _to, int _val, int _id)
    {
        from = _from;
        to = _to;
        id = _id;
        val = _val;
    }
};
bool cmp(edge e1, edge e2)
{
    if(e1.val != e2.val)return (e1.val < e2.val);
    return (e1.id < e2.id);
}
vector < edge > g;
void read()
{
    cin >> n >> m >> q;

    int ff, tt, vv;
    for (int i = 1; i <= m; ++ i)
    {
        cin >> ff >> tt >> vv;

       g.push_back(edge(ff, tt, vv, i));
    }
  //  cout << "sorted ok" << endl;
   sort(g.begin(), g.end(), cmp);
  // cout << "sorted ok" << endl;
}
int p[MAXN], sz[MAXN];
void init()
{
    for (int i = 1; i <= n; ++ i)
    {
        p[i] = i;
        sz[i] = 1;
    }
}
int ver, need;
int find_parent(int i)
{
    if(i == p[i])return i;
    else return (p[i] = find_parent(p[i]));
}

void connect(int x, int y)
{
    x = find_parent(x);
    y = find_parent(y);
    if(x == y)return;
    if(y == ver)swap(x, y);
    sz[x] += sz[y];
    p[y] = x;
}
void solve()
{
    init();

    int i = -1;
    int ans = 0;
    while(sz[ver] <= need)
    {
        i ++;
        int fromm = g[i].from;
        int too = g[i].to;
        connect(fromm, too);
        ans = g[i].val;
    }
    cout << ans << endl;
}
void queries()
{
    while(q --)
    {
        cin >> ver >> need;
        solve();
    }
}
int main()
{
   speed();
   read();
   queries();
    return 0;
}
