#include<bits/stdc++.h>
using namespace std;
const int N_MAX=200010,Q_MAX=200010,M_MAX=400010;
void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
}
struct vryzka{
    int dest;
    int cost;
};
int n,m,questions;
vector<vryzka> conn[N_MAX];
int mini[N_MAX];
void input(){
    cin>>n>>m>>questions;
    for(int i=0; i<=n+7; i++)
        mini[i]=INT_MAX;
    int u,v,d;
    for(int i=0; i<m; i++){
        cin>>u>>v>>d;
        conn[u].push_back({v,d});
        conn[v].push_back({u,d});
        mini[u]=min(mini[u],d);
        mini[v]=min(mini[v],d);
    }
}
bool visited[N_MAX];
auto cmp=[](vryzka left,vryzka right){return left.cost>right.cost;};
priority_queue<vryzka,vector<vryzka>,decltype(cmp)> q(cmp);
int f(int x,int k){
    int cnt=0,ans=1;
    while(cnt<k){
        vryzka curr=q.top();
        q.pop();
        if(visited[curr.dest])continue;
        visited[curr.dest]=true;
        cnt++;
        if(ans<curr.cost)ans=curr.cost;
        for(vryzka v:conn[curr.dest])
            if(!visited[v.dest])
                q.push(v);
    }
    return ans;
}
void cleanup(){
    while(!q.empty())q.pop();
    fill(visited,visited+n+1,false);
}
void solve(){
    int x,k;
    while(questions--){
        cin>>x>>k;
        if(k==1){
            cout<<mini[x]<<'\n';
            continue;
        }
        cleanup();
        visited[x]=true;
        for(vryzka v:conn[x])
            q.push(v);
        cout<<f(x,k)<<'\n';
    }
}
int main(){
fastIO();
input();
    solve();
return 0;
}