#include <bits/stdc++.h>
#define MAXN 200008
#define v first
#define pari second
#define endl '\n'
using namespace std;
vector<pair<int,int>> edges[MAXN];
int cost[MAXN];
void dfs(int s)
{
    for (auto edge : edges[s])
    {
        int w = max(edge.pari, cost[s]);
        if ( cost[edge.v] == -1 )
        {
            cost[edge.v] = w;
            //cerr << "v " << edge.v << " -> " << w << endl;
            dfs( edge.v );
        }
        else if ( w < cost[edge.v] )
        {
             //cerr << "v " << edge.v << " -> " << w << endl;;
            cost[edge.v] = w;
            dfs( edge.v );
        }
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n, m, q; cin >> n >> m >> q;
    for (int j=0; j<m; j++)
    {
        int b, e, d; cin >> b >> e >> d;
        edges[b].push_back({e, d});
        edges[e].push_back({b, d});
    }

    for (int h=0; h<q; h++)
    {
        int b, k; cin >> b >> k;
        memset(cost, -1, sizeof(cost[0])*(n+1));
        cost[b] = 0;
        dfs(b);
        multiset<int> s;
        for (int i=1; i<=n; i++)
            {
                s.insert( cost[i] );
                //cerr << "cost[" << i << "]=" << cost[i] << endl;
            }

        auto it = s.begin();
        for (int i=0; i<k; i++)
        {
            //cerr << (*it) << " ";
            it++;
        }
        //cerr << endl;
        cout << (*it) << endl;
    }

}
/**
13 18 7
1 2 4
1 3 1
2 4 6
2 5 4
2 6 2
3 6 3
3 10 4
4 7 6
5 8 5
6 8 2
10 11 6
7 8 5
11 12 7
12 8 6
7 9 5
9 13 6
13 8 1
5 6 3
13 6
7 9
3 1
13 12
12 1
8 2
5 6
----------------
3
5
1
6
6
2
3
*/
