#include <bits/stdc++.h>
#define MAXN 200008
#define v first
#define pari second
#define endl '\n'
using namespace std;
vector<pair<int,int>> edges[MAXN];
vector<pair<int,int>> reversed[MAXN];
int cost[MAXN];
int minEdge[MAXN];
int k;
void dfs(int s, int dd)
{
    for (auto edge : edges[s])
    {
        int w = max(edge.pari, cost[s]);
        if ( w > dd ) continue;
        if ( cost[edge.v] == -1 )
        {
            cost[edge.v] = w;
            //cerr << "v " << edge.v << " -> " << w << endl;
            dfs( edge.v, dd );
        }
        else if ( w < cost[edge.v] )
        {
            //cerr << "v " << edge.v << " -> " << w << endl;;
            cost[edge.v] = w;
            dfs( edge.v, dd );
        }
    }
}
set <int> diffD;
int ans[MAXN];int n;
bool findSCC(int dd)
{

    for (int i=1; i<=n; i++)
    {
        if ( cost[i] == -1 )
        {
            memset(cost, -1, sizeof(cost));
            dfs(i, dd);
            set<int> s;

            for (int i=1; i<=n; i++)
            {
                if ( cost[i] != -1 )
                    s.insert(i);
            }
            if ( (int)s.size() >= k )
            {
                for (auto ss : s)
                {
                    if ( dd < ans[ss] || !ans[ss] )
                    {
                        cerr << "ans[" << ss << "]=" << dd << endl;
                        ans[ss] = dd;
                    }
                }
            }
            if ( s.size() == n ) return true;
        }
    }
    return false;

}
void buildSCC()
{
    for (auto dd : diffD)
    {
        if ( findSCC(dd) ) break;
    }
}
void solve(int b)
{
    cout << ans[b] << endl;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int m, q;
    cin >> n >> m >> q;
    for (int j=0; j<m; j++)
    {
        int b, e, d;
        cin >> b >> e >> d;
        diffD.insert(d);
        edges[b].push_back({e, d});
        edges[e].push_back({b, d});

    }
    int b;
    cin >> b >> k;
    buildSCC();
    solve(b);
    for (int h=1; h<q; h++)
    {
        cin >> b >> k;
        solve(b);
    }

}
/**
13 18 7
1 2 4
1 3 1
2 4 6
2 5 4
2 6 2
3 6 3
3 10 4
4 7 6
5 8 5
6 8 2
10 11 6
7 8 5
11 12 7
12 8 6
7 9 5
9 13 6
13 8 1
5 6 3
13 6
7 9
3 1
13 12
12 1
8 2
5 6
----------------
3
5
1
6
6
2
3
*/

