#include <bits/stdc++.h>
#define MAXN 200008
#define v first
#define pari second
#define endl '\n'
using namespace std;
vector<pair<int,int>> edges[MAXN];
int cost[MAXN];
int minEdge[MAXN];
priority_queue<pair<int,int>> pq;
int n;
void dijkstra(int s)
{
    cost[s] = 0;
    pq.push({0, s});
    while (!pq.empty())
    {
        int curr = pq.top().second;
        int d = -pq.top().first;
        pq.pop();
        if ( d > cost[curr] ) continue;
        bool f = true;
        for (int i=1; i<=n; i++)
            if ( cost[i] == -1 )
        {
            f = false; break;
        }
        if ( f ) break;
        for (auto edge : edges[curr])
        {
            int w;
            if ( edge.pari > cost[curr] ) w = edge.pari;
            else w = cost[curr];

            if ( w < cost[edge.v] || cost[edge.v] == -1 )
            {
                cost[edge.v] = w;
                pq.push({ -w, edge.v });
            }

        }
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int  m, q;
    cin >> n >> m >> q;
    for (int j=0; j<m; j++)
    {
        int b, e, d;
        cin >> b >> e >> d;
        edges[b].push_back({e, d});
        edges[e].push_back({b, d});
        if ( d < minEdge[b] || !minEdge[b] ) minEdge[b] = d;
        if ( d < minEdge[e] || !minEdge[e] ) minEdge[e] = d;
    }

    for (int h=0; h<q; h++)
    {
        int b, k;
        cin >> b >> k;

        if ( k != 1 )
        {
            memset(cost, -1, sizeof(cost[0])*(n+1));
            cost[b] = 0;
            dijkstra(b);
            sort(cost+1, cost+n+1);
            cout << cost[k+1] << endl;
        }
        else
        {
            cout << minEdge[b] << endl;
        }


    }

}
/**
13 18 7
1 2 4
1 3 1
2 4 6
2 5 4
2 6 2
3 6 3
3 10 4
4 7 6
5 8 5
6 8 2
10 11 6
7 8 5
11 12 7
12 8 6
7 9 5
9 13 6
13 8 1
5 6 3
13 6
7 9
3 1
13 12
12 1
8 2
5 6
----------------
3
5
1
6
6
2
3
*/
