#include <bits/stdc++.h>
using namespace std;

struct query
{
    int x,y,z;
    query(){}
    query(int _x,int _y,int _z)
    {
        x=_x;
        y=_y;
        z=_z;
    }
};

vector<query> ans;

int n,m;
int t[5001][5001];
int cnt;
void make1(int i,int l,int r,int row,int num,int low)
{
    if(l==r)
    {
        if(low)t[num][i]=(row-1)*m+l;
        else
        {
            t[num][i]=cnt++;
            ans.push_back({t[num][i],t[num*2][i],t[num*2+1][i]});
        }
        return;
    }

    int mid=(l+r)/2;
    make1(i*2,l,mid,row,num,low);
    make1(i*2+1,mid+1,r,row,num,low);
    t[num][i]=cnt++;
    ans.push_back({t[num][i],t[num][i*2],t[num][i*2+1]});
}

void make2(int i,int l,int r)
{
    if(l==r)
    {
        make1(1,1,m,l,i,1);
        return;
    }
    int mid=(l+r)/2;
    make2(i*2,l,mid);
    make2(i*2+1,mid+1,r);

    make1(1,1,m,0,i,0);
}

vector<int> v;
void query2(int i,int l,int r,int ql,int qr,int idx)
{
    if(ql>qr)return;
    if(ql<=l&&r<=qr)
    {
        v.push_back(t[idx][i]);
        return;
    }

    int mid=(l+r)/2;
    query2(i*2,l,mid,ql,min(qr,mid),idx);
    query2(i*2+1,mid+1,r,max(mid+1,ql),qr,idx);
}

void query(int i,int l,int r,int li,int ri,int lj,int rj)
{
    if(li>ri)return;
    if(li<=l&&r<=ri)
    {
        query2(1,1,m,lj,rj,i);
        return;
    }

    int mid=(l+r)/2;
    query(i*2,l,mid,li,min(ri,mid),lj,rj);
    query(i*2+1,mid+1,r,max(li,mid+1),ri,lj,rj);
}

int merge_(int l,int r)
{
    if(l==r)return v[l];
    int mid=(l+r)/2;
    int x=merge_(l,mid);
    int y=merge_(mid+1,r);
    ans.push_back({cnt,x,y});
    cnt++;
    return cnt-1;
}
int a[128][128];
void solve()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            v.clear();
            query(1,1,n,1,i,1,j);
            a[i][j]=merge_(0,v.size()-1);
        }
    }
}

void print()
{
    cout<<cnt-1<<endl;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cout<<a[i][j]<<" ";
        }
        cout<<endl;
    }

    for(int i=0;i<ans.size();i++)
    {
        cout<<ans[i].x<<" = "<<ans[i].y<<" + "<<ans[i].z<<endl;
    }

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin>>n>>m;
    cnt=n*m+1;
    make2(1,1,n);
    solve();
    print();
    return 0;
}
