#include<bits/stdc++.h>
using namespace std;
const int MAXN = 200007;
long long INF = 10000000007;
int m,n,q;
vector<pair<int,int>> g[MAXN];
long long dist[MAXN];
void Dijkstra(int x){
    for(int i = 1 ; i <= n ; i++) dist[i] = INF;
    priority_queue<pair<int,int>> pq;
    pq.push({0,x});
    int u, d, v;
    while(!pq.empty()){
        d = - pq.top().first;
        u = pq.top().second;
        pq.pop();
        if(d >= dist[u]) continue;
        dist[u] = d;
        for(int i = 0 ; i < g[u].size() ; i++){
            v = g[u][i].first;
            if(dist[v] > max(d,g[u][i].second)){
                pq.push({-max(d,g[u][i].second), v});
            }
        }
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m>>q;
    int u, v, d;
    for(int i = 0 ; i < m ; i++){
        cin>>u>>v>>d;
        g[u].push_back({v,d});
        g[v].push_back({u,d});
    }
    int x,k;
    for(int i = 0 ; i < q ; i++){
        cin>>x>>k;
        Dijkstra(x);
        sort(dist+1,dist+(n+1));
        cout<<dist[k+1]<<"\n";
    }
}
