#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <utility>
#include <queue>

#define pb(x) push_back(x)
#define INF 1000000005
#define LINF 1000000000000000005
#define maxn 200005
#define X first
#define Y second


using namespace std;


typedef long long ll;
typedef pair<int,int> pll;

struct edge
{
    int to , c;
    edge(){};
    edge(int _to , int _c)
    {
        to = _to;
        c = _c;
    }
};
vector <edge> v[maxn];
int n , m , q;

int dist[2][maxn];
int minn[maxn];

void read()
{
    cin >> n >> m >> q;
    
    for(int i = 1; i <= n; i++)
        minn[i] = 1e9;
    
    int a , b , c;
    for(int i = 1; i <= m; i++)
    {
        cin >> a >> b >> c;
        v[a].push_back({b , c});
        v[b].push_back({a , c});
    minn[a] = min(c , minn[a]);
    minn[b] = min(c , minn[b]);
    }
}

void dijkstra(int start)
{
    priority_queue <pll , vector <pll> , greater <> > q;
    q.push({0 , start});
    for(int i = 1; i <= n; i++)
        dist[1][i] = INF;
    dist[1][start] = 0;


    while(q.size() != 0)
    {
        pll node = q.top();
        q.pop();
        for(auto& nb : v[node.Y])
        {
            int e = max(node.X , nb.c);
            if(dist[1][nb.to] > e)
            {
                dist[1][nb.to] = e;
                q.push({e , nb.to});
            }
        }
    }

}


int ans[maxn];
void solve()
{
    int k , x;
    vector <pll> qq;
    for(int i = 0; i < q; i++)
    {
        cin >> x >> k;
        cout << minn[x] << endl;
        qq.push_back({k , i});
    }
    return;
    sort(qq.begin() , qq.end());

    dijkstra(x);

    sort(dist[1] + 1 , dist[1] + n + 1);
    int br = 0;
    int curans = 0;
    int p = 1;

    for(int i = 0; i < q; i++)
    {
        while(qq[i].X > br)
        {
            if(p == n)
            {
                br = 1e9;
                curans = -1;
            }
            br++;
            p++;
            curans = dist[1][p];
        }
        //cout << "-> " << curans << endl;
        ans[qq[i].Y] = curans;
    }

    for(int i = 0; i < q; i++)
        cout << ans[i] << endl;
}





int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    read();
    solve();

    return 0;
}
