#include <iostream>
#include <vector>

#define pb(x) push_back(x)
#define INF 1000000005
#define LINF 1000000000000000005
#define maxn 64

using namespace std;

struct command
{
    char type;
    int a, b;
    command() {};
    command(int _a, char _type, int _b)
    {
        a = _a;
        type = _type;;
        b = _b;
    }
};
vector <command> v;
int n, m;

int get_idx(int i, int j)
{
    return (i - 1) * m + j;
}



int ans[maxn][maxn];
void read()
{
    cin >> n >> m;
}


void solve()
{
    ans[1][1] = 1;

    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
        {
            if(i == 1 && j == 1)
                continue;

            if(i == 1)
            {
                //cout << "-> " << i << " " << j << " " << ans[i][j - 1] << endl;

                v.push_back({ans[i][j - 1] , '+' , get_idx(i , j)});
                ans[i][j] = v.size() + n * m;
                continue;
            }

            if(j == 1)
            {
                v.push_back({ans[i - 1][j] , '+' , get_idx(i , j)});
                ans[i][j] = v.size() + n * m;
                continue;
            }

            v.push_back({ans[i][j - 1] , '+' , ans[i - 1][j]});
            int _new = v.size() + n * m;
            v.push_back({_new , '-' , ans[i - 1][j - 1]});
            _new = v.size() + n * m;
            v.push_back({_new , '+' , get_idx(i , j)});
            ans[i][j] = v.size() + n * m;
        }

    cout << v.size() + n * m << endl;
    for(int i = 1; i <= n; i++ , cout << endl)
        for(int j = 1; j <= m; j++)
            cout << ans[i][j] << " ";

    for(int i = 0; i < v.size(); i++)
        cout << i + 1 + n * m << " = " << v[i].a << " " << v[i].type << " " << v[i].b << endl;
}





int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    read();
    solve();

    return 0;
}
